#!/bin/sh
#
### rc.z_B2T , the "Backup-to-Tar" program
### language is "SHELL"
#
### testing GTK-dialog simplified with flag control of progress dialog.
### testing with default GTK-cialog colors (black/lightblue) .

### 'B2T.sh' naming format so GEANY sees a 'script' executable .
### 'rc.z_B2T.sh' to indicate preferred location of program script.
### ok to rename to "B2T.sh" for normal use, installed anywhere.

### 200603-0958 gae, ref ### Pupsave_Zipit original v12 had "export LOCDEFAULT="/mnt/home"

########################################################################
#
#  Standard GNU General Public License Header :
#
#  2020 root <glen.e77is@Gmail.com>
#  website : www.GeoCities.WS/glene77is
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  To received a copy of the GNU General Public License
#  write to the Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston,
#  MA 02110-1301, USA.
#
#######################################################################
#  tar (GNU tar) 1.29
#  Copyright (C) 2015 Free Software Foundation, Inc.
#  License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>.
#  This is free software: you are free to change and redistribute it.
#  There is NO WARRANTY, to the extent permitted by law.
#  Written by John Gilmore and Jay Fenlason.
#
#######################################################################
### Developed using Geany,
### with option "Execute" for trace in "BASH Terminal" for debug.
### All of our "echo" lines will show trace in this terminal screen.
### Using Geany with option "Execute" will allow good debugging in "BASH Terminal"
#
########################################################################
#
#
#
########################################################################
# pupsave-back-2-tar ("B2T")
### ### /intrd/mnt/dev_save/MY_/usr-share/gae-Dev
#
# 2byte wrote the original pupsave-backup v.1.2.1, 2011 .
# Sigberg rewrote into the Fuller version, v.1.3,  2013 .
# glene77is rewrote totally into simpler form, as B2T, 2019-2020 .
# website : www.GeoCities.WS/glene77is
#
############################################################################################
# gae developed 'pup_backup-to-tar', "B2T". 201911 <-> 202005.
# B2T : our code was based on the idea behind pupsave-backup 1.2.1
# see Murga http://murga-linux.com/puppy/viewtopic.php?p=1050224#1050224
# B2T version is running on 'UpupBB-19.03 +20'
# B2T uses gtkdialog -v = 0.8.4 release , Laszlo Pere, Thunor.
# B2T has been tested on Puppy distros :  Slacko, Xenial, Tahr, UpupBB .
# B2T has been tested on saveFOLDER and saveFILE.4fs systems.
# B2T depends on gtkdialog for Progress Dialog, Help-splash and Main-Gui-splash screens.
# B2T depends on Puppy Linux "PUPSTATE" file for system variables.
# B2T has been designed/tested to work with Puppy Linux Frugal installs.
# B2T has been designed/tested to work with Puppy Linux formats Ext2,3,4.
# B2T has been tested to work with Puppy Linux Frugal, saveFOLDER systems.
# B2T has been tested to work with Puppy Linux Frugal, saveFILE.4fs systems.
# B2T has many 'echo' trace messaages, which appear in the Geany, Execute, Terminal window.
############################################################################################
#
#
#
#########################################################################################
### 191113-1116
###     gae, first bug killed was the lingering splash banner
###         which persisted, and was not killed properly at end of program.
###         and persisted forever on desktop, until Refresh "X" or "Reboot"
###     gae, that bug, and other complexities, led to total re-write
###             from scratch.
###     gae, Design Philosophy : "Simple, Readable, Modifiabled"
###
###
### 191114-0800, gae, defaulted "tar.gz" option
### 191122, gae, inserted proper credits for authorship and modifications.
### 191123, gae, cleanup
### 191127, gae, touch-up notes
### 191201, gae, cull extra dialog box, write compact date, gae
### 191203, gae, adjust credits, mod help.
### 191210, gae, minor touch-ups.
### 191212, gae, ERRORMSG is OK, sometimes empty, sometimes has string
### 191218, gae, touch-up
### 191231, gae, touch-up
### 200107, gae, touch-up
### 200120, gae, touch-up
### 200129, gae, more tracing of functions.
###         Some original functions are not used, will be culled.
###
### 200130, trace & debug.
### 200130,1417
### 200131,1050
### 200202-0834
### 200207-0500 gae, backtracked several days to 200203, to rewrite a bug.
###
###     Original has always had bug " du : zero length filename " from terminal window.
###     Original Code calls "du" two times.  if 'B2T_Backup', then "du" Needs tracing.
###
###     Still trace "destfile" et al
###     in order to pull source and destination file names from PUPSTATE var PUPSAVE.
###     The orig code was developed in layers,
###     and has needlessly roundabout expressions
###     and lacks required documentation.
###
### 200208-0500 gae, use Geany with [ Execute / Terminal / echo "" ] function .
###
### 200208-1400 gae
### 200208-1832 gae PUPSTATE var OK ! in calling tar -c -z -f  lcPupTrg lcPupSrc !
### 200208-2226
### 200209-0538 gae, restore from 08, continue stripping extraneous code.
### 200209-1400 gae, continue stripping extraneous code.
### 200209-1535 gae, publish to Murga
### 200209-1950 gae, bug in MBavailable
### 200210-0430 gae, MBavailable works.
### 200210-1742 gae, checking last block "$EXIT" = "BACKUP"
### 200210-1851 gae, DateTimeStamp now includes %S seconds(01-60). Dupe prohibited.
### 200211-1124 gae, restored.
### 200211-1321 gae, ok
### 200211-1405 gae, ok
### 200211-1416 gae, ok
### 200212-2000 gae, ok
### 200213-0424 gae, added title "B2T" in Main Gui
###                  trace savePATH vs saveFOLDER via CAMB .
### 200213-1700 gae, rebuild into 20212-2000
### 200216-0630 gae, continued trace and mod.
### 200217-0400 gae, continued trace and mod.
### 200217-0742
### 200220-0603
### 200221, gae
### 200224-0615 gae, /intrd/mnt/dev_save/MY_/usr-share/gae-Dev
### 200224-2105 gae, Tested on EXT2,3,4 formated partitions.
### 200226-0600 gae, Total ReWrite from near scratch.
### 200229-1625 gae, TEST routines transferred to rc.z_TST
### 200301-0552
### 200301-1622
### 200302-0525
### 200302-1830
### 200304-0400
### 200304-1520
### 200306-1511
### 200310-0430 gae, re-wrote the Main()-GUI
###             tested alternative branching code.
### 200314-0408
### 200315-1313
### 200317-1813
### 200320-0600
### 200321-0730
### 200321-0930 gae, copied "SYS_" subroutines from 'MGN"
### 200323-1500 gae, tested B2T vs B2U code, OK.
### 200324-1500
### 200324-1800
### 200325-0856 gae, install Sys_ShowSplash
### 200325-0950 gae, smoothing repeated applications of Sys_ShowSplash
### 200327-0400
### 200330-0943
### 200331-0606
### 200404-1643
### 200408-0620
### 200411-0400
### 200412-0700
### 200414-0930
### 200415-0534
### 200418-0939
### 200419-1304 gae, restored, Sys_ShowSplash bug.
### 200419-1709
### 200426-0933
### 200427-0455
### 200427-1044 gae, embedded TAROPT near "tar" run command .
### 200430-1012 gae, restored from last good script, in /etc/rc.d
### 200430-1826 gae, removed Sys_ShowSplash bug.
### 200501-1616 gae, house-cleaning.
### 200502-0700 gae, removed gtk-dialog for test, to DavidS45, removed GTK
### 200502-0730 gae, removed gtk-dialog for test, to DavidS45, Simplified GTK , no colors
### 200502-1502 gae, MGN calling for 'No-Gui' .
### 200502-1951 gae, imported orig 'B2T_Show_Splash' from HB v.1.2., to test.
### 200503-0500 gae, flag for controlling gtkdialog 'splash' screens, flags at head of "main splash" .
###     NOTE: from DavidS45
###     /usr/lib/gtkdialog/box_splash -fg yellow -bg darkred -close never -text "
###     inhibits gtkdialog display in Wheezy.
###     That led to developing a version with No GtkDialog splashes.
###     Made use of gtkdialog splashes to HB.v.1.2 default.
###     Wheezy problem persisted, along with other ancient Puppy Distro systems.
###     Decision not to pursue extreme "BackWard Compatibility".
###
### 200504-0610 gae, saved as B2Tcfg.sh dts .  Dev Cfg needs more work.
###                 restore & resume cleaning B2T code
###                 Decided Cfg is mandatory, stopped development.
###                 Cfg conflicts with "Simple" guideline.
### 200504-0900 gae, tested gtkdialog splashes , again.
### 200505-0600 gae, Set gtkdialog splashes to HB.v.1.2 default.
### 200506-0700 gae, housekeeping
### 200506-1045 gae, develop a 'looping' BackUpRun, ReStart.
### 200506-1127 gae, develop loop based on "eval" , rm lock-file, exit
### 200506-2036 gae, housekeeping
### 200508-0430 gae, begin dev on "p-Cold-Backup" 'for Puppy SaveDATA' .
### 200509-0713 gae, housekeeping
### 200509-1518 gae, housekeeping
### 200510-0833 gae, housekeeping
### 200511-0541 gae, updated Progress trace
### 200511-1723 gae, transferred code base to B2U. Works first time.
###                     continued "Readability" mods
### 200512-0600 gae, housekeeping, added Sys_Str2Trm
### 200514-0623
### 200515-1423
### 200519-0723
### 200522-2015 gae, update 
### 200525-0800 gae, added splash to tar trace, and notes at end of terminal display. 
### 200528-0522 gae, Src_Box
### 200529-0600 gae, rewrote "recalc" . Native error in binary not resolved. 
### 200531-0500 gae, work-around adjustments to main_GUI display horizontal position
### 200602-0509 gae, fix Help_Box
### 200603-0534 gae, traced "PWD" sys-var ("/root") , 
###                 convert into "PWDir" to match "CWDir".
### 200603-0800 gae, speed up the ReStart call process. 
### 200603-0958 gae, ref ### Pupsave_Zipit original v12 had "export LOCDEFAULT="/mnt/home"
### 200604-1100 gae, cleanup
### 200605-0700 gae, startup checks added. 
### 200506-0700 
### 200607-0500 gae, tested B2T.sh in UpupBB RAM mode. OK. 
### 200607-0500 gae, tested MGN.sh in UpupBB RAM mode. OK. 
### 200614-0545

#########################################################################################



###--- B2T_Backup -------
### PUPSTATE has PUPSAVE as the name of the savedata in use !
### savedata can be "upupbb-???.4fs" or "upupbb-???" .
### savedata can be a FILE or a FOLDER.
### B2T takes the savedata as Source name and runs thru Tar.Gz .
### Tar does not care what kind of file or folder is Source data.
### Tar does not care what kind of file or folder is Source data.
###


#########################################################################################

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function Sys_SetVerDts() {
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    #
    ### called by Main ()
    ### param
    ### purpose : generate system date/time constants.
    ### rationale : One Time Manual Entry
    ### note :
    #
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^####
### Manual Entry for  Developers Version  Date-Time-Stamp ################
export gcVerDts="200614-0545"
### developer enters this manually for Each Version Development.
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

    ### Date : grave-mark in date () !!!
    ###  Dts="`date +%y%m%d-%H%M-%S`"
    ### addust from default "z" time 
    ###   to local mid-america dts ( -5 hours ).
    lcNowDts=""
    lcNowDts="`date +%y%m%d%H%M`"
    lcNowDts="${lcNowDts:0:6}-${lcNowDts:6:4}"
    gcNowDts="${lcNowDts}-local"
    export gcNowDts="${lcNowDts}"



###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
export lcSysDts="`date +%y%m%d-%H%M-%S`"
### Date : grave-mark in date () !!!

export lcSysVer="Linux puppypc3073 4.9.163-lxpup-32-pae #1 SMP Thu Mar 14 15:41:19 GMT 2019 i686 i686 i686 GNU/Linux"

export lcSysNameBase="B2T"	### used in code as label

    ### trace results to terminal screen.
    lcMsgStr="VerDts: ${gcVerDts} ......." && Sys_Str2Trm   "${lcMsgStr}"   "3" "10"
    lcMsgStr="SysDts: ${lcSysDts} ......." && Sys_Str2Trm   "${lcMsgStr}"   "3" "10"
    lcMsgStr="NowDts: ${lcNowDts} ......." && Sys_Str2Trm   "${lcMsgStr}"   "3" "10"

    ### these are a compact, non-Y2K-compliant date, gae
    ### remember to use grave-mark "`" in "date" function parameters.
    ### grave-mark is with the tilde "~" key, top row, left end.

}   ### end Sys_SetVerDate

### call 'Sys_SetVerDate' from Main ()
### current DTS is used below in Main_GUI () and Help_Box ()
#
### gcVerDts is declared/assigned at beginning (top) of program
### function B2T_SetVerDate is called at top of '=== MAIN () ==='
#########################################################################################








########################################################################
### rc.zStr2Trm	########################################################
########################################################################
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!----
function Sys_Str2Trm() {   ### active
########################################################################

    ### called by Main ()
    ### purpose: Standard Message-2-Terminal routine 
    ### param
    ### purpose : generate system date/time constants.
    ### rationale : One Time Manual Entry   for Geany "terminal" use.
    ### note :
    ### usage:
    ###    Sys_Str2Trm "string" "color" "margin"
    ###    Sys_Str2Trm "$lcMsgStr" "grn" "3"
    ###    lcMsgStr="xxx" && Sys_Str2Trm "$lcMsgStr" "grn" "3"
    ### returns: action
     
### dev param error check
### [ -z "${1}" ] && lcParStr="message"	### string
### [ -z "${2}" ] && lcParClr="5"	### color : 1,2,3,4,5   or  red,grn,yel,blu,pur
### [ -z "${3}" ] && lcParMrg="3" ### margin : 1,2,3,4,5 where mrg=5,10,15,20,25,30

##### begin: rc.zStr2Trm ##################################################
##### begin: function Sys_Str2Trm
#
### capture all params
lcParStr=${1}	### string message
lcParClr=${2}	### color name or number
lcParMrg=${3}	### margin number 1,2,3,4,5,etc
#
### rc.zStr2Trm	########################################################
### trap margin from #3 param |"number"   ### default left-margin=3 ###
#
case "${lcParMrg}" in
    0|"0") /bin/echo -n -e ""  ;; 
    1|"1") /bin/echo -n -e "\\033[1G"  ;; 
    2|"2") /bin/echo -n -e "\\033[2G"  ;;
    3|"3") /bin/echo -n -e "\\033[3G"  ;; 
    4|"4") /bin/echo -n -e "\\033[4G"  ;; 
    5|"5") /bin/echo -n -e "\\033[5G"  ;;
    5|"6") /bin/echo -n -e "\\033[6G"  ;; 
    5|"7") /bin/echo -n -e "\\033[7G"  ;; 
    5|"8") /bin/echo -n -e "\\033[8G"  ;;
    5|"9") /bin/echo -n -e "\\033[9G"  ;; 
    10|"10") /bin/echo -n -e "\\033[10G"  ;; 
    15|"15") /bin/echo -n -e "\\033[15G"  ;;
    20|"20") /bin/echo -n -e "\\033[20G"  ;; 
    30|"30") /bin/echo -n -e "\\033[30G"  ;; 
    *) /bin/echo -n -e "\\033[3G"  ;;
esac
### rc.zStr2Trm	########################################################
### trap color from #2 param "name"|"number"   ### default is "yel" 
case "${lcParClr}" in
    red|"1") /bin/echo -n -e "\\033[1;31m"  ;;
    grn|"2") /bin/echo -n -e "\\033[1;32m"  ;;
    yel|"3") /bin/echo -n -e "\\033[1;33m"  ;; 
    blu|"4") /bin/echo -n -e "\\033[1;34m"  ;;
    pur|"5") /bin/echo -n -e "\\033[1;35m"  ;;
    cyn|"6") /bin/echo -n -e "\\033[1;36m"  ;;
    wht|"7") /bin/echo -n -e "\\033[1;37m"  ;;
    wblu|"8") /bin/echo -n -e "\\033[4;7;30m"  ;; ### blu   
    wgrn|"9") /bin/echo -n -e "\\033[3;7;30m"  ;; ### grn
    wgry|"10") /bin/echo -n -e "\\033[5;7;30m"  ;; ### gry
    *)	/bin/echo -n -e "\\033[1;33m"  ;;
esac
### rc.zStr2Trm	########################################################
lcDevConsole=" > /dev/console"
#~ lcDevConsole=""  
###   ${lcDevConsole}
	/bin/echo -n "$lcParStr" 
	/bin/echo -e "\\033[0;m" 
	return  0
###
}   ### end: Sys_Str2Trm
##### end: Sys_Str2Trm ##################################################
##### end: Sys_Str2Trm ##################################################
##### end: Sys_Str2Trm ##################################################





#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!----
function B2T_Show_Splash() {    ### from orig Hot-Backup v.1.2
    ### called by Alternate "DONE" progress dialog splash.
    ### intended to be a 'bare minimum' progress dialog splash.
    ### receives no 'color' param , should show default black/grey .
    ### receives param only for "text" extracted via "$@" 
    ### returns: action
	/usr/lib/gtkdialog/box_splash -close never -text "$@" &
	pidx=$!
}   ### end: B2T_Show_Splash


#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!----
function B2T_Splash_Trace() {   ### not active
    ### purpose : Basic Msg2Str
    ### B2T_Splash_Trace "MsgStr" 
    ### has been replaced by "Sys_Str2Trm()"
    ### returns: action
    lcParMsg=${1}
    #~ lcParClr=${2}
    #~ lcGuiColor="green"
    #~ export lcGuiColor="green"
    echo -n -e "\\033[0G\\033[1;32m"   #green [done] msg.
    echo -n "***${lcParMsg}"   #done
    echo -e "\\033[0;39m"  
}   ### end B2T_Splash_Trace



#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!----
function Sys_Src_Box() {    ### active
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!----
    ###
    ### called by : Main_GUI, small button 
    ### receives param : none
    ### purpose :  direct link from Main_GUI , returns to same.
    ### returns: action
        echo ">>> begin Sys_Src_Box >>>"
        lcSourceTxt="/tmp/B2T_source.txt"
    cat $0 > ${lcSourceTxt}     ### $ ZERO ### deposits copy of source code
    xmessage -bg LemonChiffon1 -borderless -center -file ${lcSourceTxt} -wrap
        pidx=$!
        kill $pidx
        rm -f ${lcSourceTxt} ### removes tmp copy of source code
        echo "<<< end Sys_Src_Box <<<"
    ###
    ### Note on 'xmessage' method 
    ### when 
    ###     modeled as the "Help" method, embedded in 'button' .
    ###     <button label="" has-focus="false">  <action>Sys_Src_Box</action>  </button>
    ### then 
    ###     "xmessage" dialog window opens, does not find contents. 
    ### however
    ###    "/usr/lib/gtkdialog/box_help" works for "Help"
    #
    #
} ### end: Sys_Src_Box




#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!----
function B2T_Help_Box() {    ### active
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!----
    ###
    ### called by : Main_GUI
    ### receives param : none
    ### purpose :  direct link from Main_GUI , returns to same.
    ### rationale : Information for user.
    ### note : gae 191119-0900, first mod
    ###
    ### system gtkdialog "box_help" location is  '/usr/lib/gtkdialog/box_help'
    ### method: embedded in GUI line.
    ### returns: action: Main_GUI line.
    ###

	echo "\
<span background='"'brown'"'><span foreground='"'yellow'"'> "======"</span></span>\
<span background='"'yellow'"'><span foreground='"'blue'"'>"  ${lcSysNameBase} FAQ "</span></span>\
<span background='"'brown'"'><span foreground='"'yellow'"'> "===========" </span></span>

<span foreground='"'red'"'>"  "  v: ${gcVerDts}"  "</span> "  glene77is"
<span foreground='"'green'"'>" based on idea of pupsave-backup 1.2.1"</span>

<span foreground='"'red'"'>"calls Tar.gz for fast backup "</span>
<b><span foreground='"'green'"'>"Puppy 32/64-bit FRUGAL SaveFOLDER"</span></b>
<b><span foreground='"'green'"'>"Puppy 32/64-bit FRUGAL SaveFILE.4fs"</span></b>

<span foreground='"'blue'"'>"About : "</span> <span foreground='"'green'"'>"${lcSysNameBase}"</span>
<b><span foreground='"'green'"'>"${lcSysNameBase} is a Simple Program ! "</span> </b>
<b><span foreground='"'green'"'>"${lcSysNameBase} has No Bells / No Whistles ! "</span>  </b>
<b><span foreground='"'green'"'>"${lcSysNameBase} is easy to Read / Modify ! "</span>  </b>
.
<span foreground='"'blue'"'>"${lcSysNameBase} is designed specifically for"</span> <span foreground='"'blue'"'>"Puppy Linux "</span>
<span foreground='"'red'"'>"   32/64-bit Frugal" "\'saveFOLDER\' "</span>
<span foreground='"'red'"'>"   32/64-bit Frugal" "\'saveFILE.4fs\' "</span>
<b>1)</b> ${lcSysNameBase} automatically appends
   the DTS yr-mo-dy-seconds stamp
   to the Backup file .tar.gz name.
   This kills possible duplications !
<b>2)</b> ${lcSysNameBase} backs up
   your system SaveDATA
   as it exists <span foreground='"'red'"'>currently.</span>
<span foreground='"'green'"'>Will NOT run "SnapMergePuppy"
   to update the 'saveDATA'.</span>

To restore:
'double-click the saveDATA '
'XArchive', will 'Extract all' from inside
<b>saveDATA.BKP---tar.gz</b> file.

<span  background='"'white'"'foreground='"'blue'"'>"Authors note about '${lcSysNameBase}' design goal:"</span>
${lcSysNameBase} code is  <span background='"'white'"' foreground='"'red'"'>"simplified code "</span>
${lcSysNameBase} code is  <span background='"'green'"' foreground='"'yellow'"'>"readable code "</span>
${lcSysNameBase} code is  <span background='"'blue'"' foreground='"'yellow'"'>"modifiable code "</span>

${lcSysNameBase} will back-up from a 'source' to a 'target'
... exactly as prescribed in 'PUPSTATE'.
${lcSysNameBase} is conrolled by the 'PUPSTATE' var
... as written by the Puppy Linux OS .
${lcSysNameBase} PUPSTATE contains the known universe
... about currently running Puppy OS.
${lcSysNameBase} will use 'PUPSTATE' data
... to find the Source and Target .
${lcSysNameBase} can be modified to back-up
... ANY 'source' to any 'target'.




${lcSysNameBase}  is <span foreground='"'blue'"'>"written for "</span>
... <span foreground='"'brown'"'>"'Puppy Linux Frugal installs: Barry Kauler method '"</span>
${lcSysNameBase} <span foreground='"'green'"'>"backup only the current 'save-DATA'"</span>
${lcSysNameBase} <span foreground='"'green'"'>"calls .tar fast compression"</span>
${lcSysNameBase} <span foreground='"'green'"'>"appends \'.BKP-Date/Time/Seconds\'"</span>
${lcSysNameBase} <span foreground='"'green'"'>"does not call 'SnapMergePuppy'"</span>
${lcSysNameBase} has no extra splash screens.
${lcSysNameBase} has no extra options.
${lcSysNameBase} code contains authors notes .
${lcSysNameBase} Help screen is expanded with more notes.

<span background='"'black'"' foreground='"'white'"'>"Further Reading"</span> links to Murga-Linux
under Murga's "\'FileSystem\'" topic
which contains our "\'current-version.zip\'"
and user notes.


<span foreground='"'red'"'>"Note on running executable BASH script :"</span>
Always check the file "\'set action\'"
... ' $ @ '  'Use-Command'
Always check the file "\'type\'"
... 'Exec'
Always check the file "\'Properties\'"
... 'Exec'
Always check the file "\'Permissions\'"
...'Executable'
Always examine other running scripts
to see how Your System is setting things.


<span foreground='"'red'"'>"Geany Debug Method :"</span>
Use the Geany Execute function
   to activate this script and run in 'BASH-Terminal'
All 'echo' commands will display for tracing.
'B2T.sh' format so GEANY sees a 'script' executable .
'rc.z_B2T.sh' indicates preferred location of script.





<span foreground='"'red'"'>" NOTE  about the ${lcSysNameBase} Lock-File method." </span>
<span foreground='"'green'"'>"   Ideally: " </span>
 If a 'lock-out' occurs,
    it will be a previous '${lcSysNameBase}'.
 The user should wait
    for the previous '${lcSysNameBase}' to finish
 then restart '${lcSysNameBase}' program.
<span foreground='"'green'"'>"   Possibly: " </span>
 the user will decide to run '${lcSysNameBase}' again,
 ... on top of itself,
 and '${lcSysNameBase}' will run again properly.
 ... there will be NO fatal fault,
 ... because ''snapmergepuppy'' is not active.
<span foreground='"'green'"'>"   Possibly:  " </span>
 the lingering 'splash' is the 'Help' screen.
 The 'Help' screen uses a 'gtkdialog/box_ok'
 therefore, the user should click the'OK' button.
<span foreground='"'green'"'>"   Sure Cure:  " </span>
 ... restart 'X' graphical server.
 ... via Puppy 'Menu'
 ... then click "Leave"  (Exit)
 ... then click "Restart Graphical Server"




... '"Help"' will run, and return to ''Main_Gui''.
... '"BackUp"' will run, 
... and then 'restart' program to ''Main_Gui''.
... Run '"${lcSysNameBase}"' script in '"Geany"' or '"ROX"' '"terminal"'
...    to view action of internal operations !

............................................................."\
> /tmp/box_help
/usr/lib/gtkdialog/box_help  /tmp/box_help  "PupSave...DATA"  \
"http://murga-linux.com/puppy/viewtopic.php?p=1050224"
}   ### end B2T_Help_Box

### remove the lingering temp file. 
rm -f "/tmp/box_help"

### /usr/lib/gtkdialog/box_help is the only dialog that is useful here.
### per /usr/lib/gtkdialog/box_help: This box displays the text in /tmp/box_help
### via this gtkdialog source code: 
###     <text xpad="10" ypad="15" use-markup="true"><input file>/tmp/box_help</input></text>
###     <input file>/tmp/box_help</input>
### thus: 
###     only one "box_help" at a time. 
###
### see B2T , B2U, MGN , GTK for gtk-dialog example "FAQ"

### "FAQ" notes:
### last lines: first param is title :
###     "MGN-Manager-Help"
### last lines: second param is "Further Reading" URL
###     "http://murga-linux.com/puppy/viewtopic.php?p=1050224"
### call function "B2T_Help_Box"

### > /tmp/box_help
### /usr/lib/gtkdialog/box_help  "Pupsave-Back-2-Tar-Help" \
### "http://murga-linux.com/puppy/viewtopic.php?p=1050224"

########################################################################




#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function Sys_PupState(){    ### active
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ###
    ### called by B2T_StartUp ()
    ### param : requires Linux Puppy  /etc/rc.d/PUPSTATE  system reference file.
    ### purpose :
    ###     consolidation of PUPSTATE into this module .
    ###     control generation of local var and system var .
    ### rationale :
    ###     Puppy writes the "state" variables into /etc/rc.d/PUPSTATE .
    ###     Puppy OS write the 'whole known universe' into this file !!!
    ###     this routine reads the "state" file
    ###     this routine declares/assigns more B2T var.
    ### returns: numerous memvar 
    #
    #-------------------------------------------------------------------
    ### begin: maintain gcVerDts ( Developer's DTS ) .
    lcVerDtsTmp="${gcVerDts}"   ### save
    #
    #--- load PUPSTATE --- from system location : "/etc/rc.d/"
    #--- Puppy OS writes the 'whole known universe' into this file !!!
    #--- At end of rc.sysinit, user can append more lines.
    . /etc/rc.d/PUPSTATE
    #
    gcVerDts="${lcVerDtsTmp}"   ### restore 
    ### end: maintain gcVerDts ( Developer's DTS ) .
    #-------------------------------------------------------------------
    ###--- Sys_PupState ---
    #
    ### direct import to similar varname.
    lcPupSave=${PUPSAVE}
    lcPupMode=${PUPMODE}
    lcPupSubDir=${PSUBDIR}
    lcPupHome=${PUP_HOME}
    lcPupSave=${PUPSAVE}
    lcPupMode=${PUPMODE}
    #
    ### maintain similarity to PUPSTATE "name"
    lcPupSaveNameRaw="PUPSAVE : ${lcPupSve}"  # B2T 'raw' savefilename from PUPSTATE file
    lcPupSaveName="`echo $lcPupSave | cut -f 3 -d "/"`" # B2T 'cut' savefilename from PUPSTATE file
    lcPupSaveNameBKP="${lcPupSaveName}.BKP-`date +%y%m%d-%H%M-%S`"     ### grave-mark in date () !!!
    lcPupSaveNameTrg="${lcPupSaveNameBKP}.tar.gz"
    lcPupSaveNameSrc="${lcPupSaveName##*/}"
    lcPupSubDir="${lcPsubDir}.BKP-`date +%y%m%d-%H%M-%S`"      ### grave-mark in date () !!!
    lcPupDistroVer=${gcSysDistroVer}  ### 'BionicPup32-19.03+18 +++'-sig
    #
    ###--- Sys_PupState ---
    #
    lcMsgStr="PupSaveNameRaw : ${lcPupSaveNameRaw}" && Sys_Str2Trm "$lcMsgStr" "pur" "3"
    ### Hard Code the Puppy Linux Default /Mnt/Home pathway 
    lcPupSaveDataName="/mnt/home""`grep PUPSAVE /etc/rc.d/PUPSTATE | cut -f 3 -d "," | cut -f 1 -d "'" `"
    lcMsgStr="saveFILE : ${lcPupSaveDataName}" && Sys_Str2Trm "$lcMsgStr" "pur" "3"
    #
    ########################################################################
 
    lcB2Tname="B2T"
    lcB2Tdts="${gcVerDts}"
    lcB2Tsleep="sleep 3"

    ########################################################################
    ###
    ### Later in the B2T Code, you will find several "export" expressions.
    ### 'export' empowers the "B2T_Main_Gui", this is a "requirement" for Main GUI.
    ### 'export' Marks each NAME for automatic export to the environment
    ###    of subsequently executed commands.
    ### If VALUE is supplied, assign VALUE before exporting.
    #
}   ### end: Sys_PupState




#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function B2T_ReStart() {    ### active
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    #
    ### called by : GTK, other selections, but not 'QUIT'
    ### param : none
    ### purpose : Handle several functions for ReStart B2T script.
    ### returns: action

    lcMsgStr="ReStarting ... " && Sys_Str2Trm "$lcMsgStr" "grn" "3"
    lcMsgStr="Remove $B2T_lockfile ..." && Sys_Str2Trm "$lcMsgStr" "grn" "3"

	rm -rf "$B2T_lockfile"  ### this is "MGN_lockfile"

    lcMsgStr="--------------------------------------------------" && Sys_Str2Trm "$lcMsgStr" "grn" "3"
    lcMsgStr="> > > Restarting $0 < < <" && Sys_Str2Trm "$lcMsgStr" "pur" "4"
    lcMsgStr="--------------------------------------------------" && Sys_Str2Trm "$lcMsgStr" "grn" "3"
    sleep 1
    
    #---------------------------------------------------------
        $0      ### $ ZERO  ### will restart this program ###
    #---------------------------------------------------------
    
    echo ""
    lcMsgStr="--------------------------------------------------" && Sys_Str2Trm "$lcMsgStr" "grn" "3"
    lcMsgStr="> > > Exit < < < Calls are Stacked ... " && Sys_Str2Trm "$lcMsgStr" "pur" "4"
    lcMsgStr="--------------------------------------------------" && Sys_Str2Trm "$lcMsgStr" "grn" "3"
    echo ""

    sleep 1

}	### end: B2T_ReStart

 

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function B2T_StartUp() {    ### active
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    #
    ### called by : Main ()
    ### param :
    ### purpose :  generalized StartUp process
    ### rationale :
    ### note: all the 'echo' are displayed in Geany, Execute, Terminal
    ### returns: memvar and action
    #
    lcMsgStr="----------------------------------------" && Sys_Str2Trm   "${lcMsgStr}"   "blu" "10"
    lcMsgStr="begin: function B2T_StartUp ..." && Sys_Str2Trm   "${lcMsgStr}"   "yel" "10"
    lcMsgStr="----------------------------------------" && Sys_Str2Trm   "${lcMsgStr}"   "blu" "10"
    lcMsgStr="calling System files  ...." && Sys_Str2Trm   "${lcMsgStr}"   "yel" "10"

    lcMsgStr=">>> call Sys_SetVerDts for date based variables... " && Sys_Str2Trm "$lcMsgStr" "grn" "3"
    Sys_SetVerDts   ###     ### B2T_StartUp calls

    lcMsgStr=">>> call Sys_PupState for System Constants ... " && Sys_Str2Trm "$lcMsgStr" "grn" "3"
    Sys_PupState        ### B2T_StartUp calls

    lcMsgStr="trace: Export var" && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"
    export lcB2Tname lcB2Tdts lcB2Tsleep

    lcMsgStr="trace: Export B2T_Help_Box .... for Main_GUI ()" && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"
    export -f B2T_Help_Box     ### GTKdialog must be visible to Main-Dialog
    export -f Sys_Src_Box 

    ### Vital: re-assignment of data into 'lcSaveData' !!!
    ### required to calculate "Backup Free Disk Space" for mainGUI
    ### gen in function B2T_StartUp as "lcSaveData"
    lcSaveData="`echo $lcPupSave | cut -f 3 -d ","`"
    ### duplicated effort : need to cull one 

    lcMsgStr="Export more variables .... for Main_GUI ()" && Sys_Str2Trm "${lcMsgStr}" "yel" "3"
    ### export these items
    ### so to be visible to the Main_GUI ()
    ### may use these, possibly.

    lcMsgStr="Export variables " && Sys_Str2Trm "${lcMsgStr}" "yel" "3"
    export GTK2_RC_Files="/root/.gtkrc-2.0"
	export SAVEFOLDER=1
	export REFRESH_INTERVAL=1000 #1 seconds

    lcMsgStr="Export Path,Name,etc. " && Sys_Str2Trm "${lcMsgStr}" "yel" "3"
    export B2T_PUPSAVE_PATH="/mnt/home${lcSaveData}"
    export B2T_PUPSAVE_NAME="${SF##*/}" ### ${SF##*/} = basename $SF not properly assigned.
    export B2T_PUPSAVE_Fn="${B2T_PUPSAVE_NAME}.BKP-`date +%y%m%d-%H%M-%S`"
    ### ref ### Pupsave_Zipit original v12 had "export LOCDEFAULT="/mnt/home"

    lcMsgStr="Export function names " && Sys_Str2Trm "${lcMsgStr}" "yel" "3"
    export -f  B2T_Show_Splash
    export -f  B2T_MBrequired
    export -f  B2T_TrgFilename
    export -f  B2T_BackUpRun

    lcMsgStr="----------------------------------------" && Sys_Str2Trm   "${lcMsgStr}"   "blu" "10"
    lcMsgStr="end: function B2T_StartUp ..." && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"
    lcMsgStr="----------------------------------------" && Sys_Str2Trm   "${lcMsgStr}"   "blu" "10"

} ### end B2T_StartUp



#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function B2T_MBrequired() {     ### not active
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    #
    ### called by: none
    ### purpose: calculate MBytes required by saveDATA 
    ### rationale: error in original 'du' calcs 
    ### usage: 
    ### returns: test calcs
    #

    ### Original Free Ram Calculation : ERROR
	aa="$(du -c -m -s "$1")"     ### -c = --total, -m = --block-size=1m, -s = --summarize
	read -r b ccc <<< "$aa"
     lcMsgStr="### Free Ram Original ### ${aa} ###" && Sys_Str2Trm "$lcMsgStr" "grn" "3"

    ### Corrected Free Ram Calculation : 
    lcFreeRam=`free | grep -o 'Mem: .*' | tr -s ' ' | cut -f 4 -d ' '` 
     lcMsgStr="### Free Ram Corrected ### ${lcFreeRam} B ###" && Sys_Str2Trm "$lcMsgStr" "grn" "3"

    #~ lcFreeRam_KB=`expr $lcFreeRam \/ 1000`
     #~ lcMsgStr="### ${lcFreeRam_KB} KB ###" && Sys_Str2Trm "$lcMsgStr" "grn" "3"

    #~ lcFreeRam_MB=`expr $lcFreeRam \/ 1000000`
     #~ lcMsgStr="### ${lcFreeRam_MB} MB ###" && Sys_Str2Trm "$lcMsgStr" "grn" "3"

    ### called by : Main_GUI
    ### param : (1) $B2T_PUPSAVE_PATH via lcSaveData
    ### purpose : calc and echo "free disk required"
    ###
    ### culled : because this is an un-needed 'bell' or 'whistle'. 
    ###     If Ram is insufficient, 
    ###     Then 'tar' will send 'error' signal, and initiate a Error_Splash. 
    ###
    ### culled : because there is an error in the binary 'du' routine. 
    ###
    ### sends : B2T_PUPSAVE_PATH works as "active echo" into Main_GUI
    ###     this way  in Main GUI
    ###     <input> 'B2T_MBrequired' "'\$B2T_PUPSAVE_PATH'" </input>
    ###     <input> 'B2T_TrgFilename' "'\$B2T_PUPSAVE_PATH'" </input>
    ### Note: Error in native binary "du" code in '-s' value. 
    ###  a=$(du -c -m -s "$1")   ### -c = --total, -m = --block-size=1m, -s = --summarize
    ###
    #
    a=$(du -shc "$1")   ### -c = --total, -h = human, -s = --summarize	
    read -r aa bb <<< "$a"
	echo -n "               Required Free Disc at least: $aa  MB"	### for GUI-Display
    #
    ### lcSaveData="`echo $lcPupSave | cut -f 3 -d ","`"
    ### used this way in mainGui
    ###     <input> 'B2T_MBrequired' "'\$B2T_PUPSAVE_PATH'" </input>
    #
    ### B2T_MBreq_var="$aa" ### not used
    #
    lcDummy=0
}	### end B2T_MBrequired
#--------------------


#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function B2T_TrgFilename() {  ### active
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ###
    ### called by: Main_GUI ()
    ### param (1)
    ### purpose : echo PUPSAVE_NAME to Main_GUI ()
    ### returns : echo to Main_GUI command line
    #
    ### function-name used in Main_GUI
	echo -n "            Backup DTS .ext : ${B2T_PUPSAVE_NAME}.BKP-`date +%y%m%d-%H%M-%S`"  ### for GUI-Display
    ### grave-mark in date () !!!
    ### declared/assigned via export
    ###  B2T_PUPSAVE_Fn="${B2T_PUPSAVE_NAME}.BKP-`date +%y%m%d-%H%M-%S`"
    ### echo "trace: PupSave_Fn: ${PUPSAVE_Fn} " ### will appear in main GUI

    ### made a compact date, gae
    ### remember to use grave-mark "`" in "date" function parameters.
    ### grave-mark is with the tilde "~" key, top row, left end.

}   ### end B2T_TrgFilename



#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function B2T_BackUpRun() {     ### Active
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    ### called by:  Main_Gui , EXIT:BackUpCall , B2T_BackUpRun
    ### purpose: Main BackUp routine
    ### called by: Main, Main_GUI, EXIT:BackUpCall for BackUpRun .
    ### param (1) : $B2T_PUPSAVE_PATH
    ### param (2) : $B2T_BACKUP_PATH
    ### purpose: Build DestFileName : $B2T_PUPSAVE_PATH $B2T_BACKUP_PATH
    ### returns :
    ### note :
    ###     When Running in 'Geany', use the 'Execute', 'BASH Terminal' mode,
    #
    ###     during backup process, "du" has error msg .
    ###     "   du: invalid zero-length file name  "
    ###     Which is displayed in the Terminal window.
    ###     Which arises when parsing past end of stack,
    ###     Which is NON-fatal.
    #
    lcMsgStr=">>> Start BackUpRun" && Sys_Str2Trm "$lcMsgStr" "grn" "3"

    sync    ### write all buffered blocks to disk
            ### will lock if SnapMergePuppy is running. 

	sleep 1

        ### "CWDir" is anacronym for "Current Working Directory" .
        ### "PWD" is system var  "/root" .
        PWDir="$PWD"
        ### param (1) is $B2T_PUPSAVE_PATH
        lcMsgStr="B2T_BackUpRun ==============================================" && Sys_Str2Trm   "${lcMsgStr}"   "blu" "3"
        lcMsgStr=">>> $ { 1% } is ${1} <<< param #1" && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"
        lcMsgStr=">>> $ { 1% /* } is ${1%/*} <<< subdir of source saveDATA" && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"
        lcMsgStr="PWDir points to '/root' path level (sys var) <" && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"
        lcMsgStr="CWDir=PWdir : $PWdir  <" && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"
        lcMsgStr="B2T_BackUpRun ==============================================" && Sys_Str2Trm   "${lcMsgStr}"   "blu" "3"
        CWDir=$PWDir  ###

    ### now, CWDir points to "/root" path level, where 'tar' thinks is 'home'.
    #
    ### this "flipping" between PWDir and CWDir is necessary because
    ###     program is receiving full /mnt/home/path/subdir/filenames
    ###     whereas
    ###     'tar' is using a "local" /path/subdir/filenames
    ### Perhaps we will write a future version of B2T
    ### including a re-write the file-name handling methods
    ### to be more simple, and still pull data from 'PUPSTATE' .
    ### Use of 'PUPSTATE' is key to standard Puppy Linux System ops. 
    ###
    ### ref ### Pupsave_Zipit original v12 had "export LOCDEFAULT="/mnt/home"
    ###
    ### -----------------------------------------------------------------
    ### B2T system runs from /root , PWDir, like most other Linux routines, 
    ### but this 'tar' routine is written to run from 'local'. 
    ###
    ### In this version of B2T :
    ### B2T system runs from /root ,
    ### but 'tar' routine is written to use the short-form file-names .
    ### (1) we flip from '/root' to 'local' /path/subdir
    ###     when calling 'tar' for saveData .
    ### or
    ### (2) we flip from '/root' to '/root'  /path/subdir/filename.4fs
    ###     when calling for saveData .
    ###
    ### we flip back to '/root' after 'tar' runs .
    ###
    ###
    ### -----------------------------------------------------------------
    ### B2T  gets control info from the system
    ###    via the system file "/etc/rc.d/PUPSTATE"
    ###    PUPSTATE is always valid at runtime for this OS.
    ### -----------------------------------------------------------------
    ###
    ### NOTE: about paramters sent to 'tar'
    ### 'tar' does not care what kind of data is the Source Data .
    ### SaveDATA can be "upupbb-???.4fs" or "upupbb-???"
    ###    or some other subdir or file .
    ### B2T takes the saveDATA as Source name and runs it thru 'Tar' .
    ###  source can be  /subdirname , containing Linux data set .
    ###  source can be  file.4fs , containing a '.4fs' Linux data set .
    ###  source can be  anything that 'tar' can read .
    ### B2T could be written to handle back-up for any file set.
    ### -----------------------------------------------------------------

###*********************************************************************
### Main Splash ### MainSplash ### Main-Splash ### Main_Splash ###

### must maintain this measured format so multiple splash fit same format !
### This is "BackGround" Image, subsequent splash will display inside Main.
### box_splash width is 40, fill it so multiple splashes fit good.

    lcMsgStr="Main Splash 'please wait' --- Terminal Ctrl-C will kill process ---" && Sys_Str2Trm   "${lcMsgStr}"   "red" "3"
    lcMsgStr="Main Splash 'please wait' --- " && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"

### USER MODIFIABLE FLAGS : #############################################

### NOTE: from DavidS45, 200502, Murga.
### /usr/lib/gtkdialog/box_splash -fg yellow -bg darkred -close never -text "
### inhibits gtkdialog display in Wheezy.
### That led to developing this version of B2T
### with "flags" to control the Gui/NoGui Splashes. 
### The gtkdialog flags are located at top of "Main_Splash" .


### USER MODIFIABLE FLAGS : #############################################
#~ lcDialogColor="  -fg black -bg lightblue  " ### this is the default from gtkdialog with 'gradient'='true' .
lcDialogColor="  -fg yellow -bg darkred  "
#~ lcDialogColor=""    ### color "" is driven by gtkdialog (black/lightblue with gradient).

### USER MODIFIABLE FLAGS : #############################################
    llDialogRun="1"     ### "1" is for running the gtkdialog splash .
                    ### "0" is for NO gtkdialog splash .
    lcMsgStr="DialogColor: ${lcDialogColor} =======" && Sys_Str2Trm   "${lcMsgStr}"   "grn" "3"
    lcMsgStr="DialogRun: ${llDialogRun} =======" && Sys_Str2Trm   "${lcMsgStr}"   "grn" "3"

        ### sample: test to allow custom splash colors
        #~ if [ ${lcDialogColor} -eq  "1" ]; then
            #~ lcSplashRun="/usr/lib/gtkdialog/box_splash  -fg yellow -bg red  -close never -text "
        #~ else
            #~ lcSplashRun="/usr/lib/gtkdialog/box_splash -close never -text "
        #~ fi

########################################################################
###*** SPLASH: Main *** MainSplash *** Main_Splash *** Main-Splash *****
###*** SPLASH: Main *** Progress Dialog Splash *************************
########################################################################
###*** SPLASH: Main *** Progress Dialog Splash *************************
###*** SPLASH: Main *** Progress Dialog Splash *************************
########################################################################

lcMsgStr="  MAIN Splash  ... Tar started: ${1%/*}" && Sys_Str2Trm "$lcMsgStr" "red" "3"

### /usr/lib/gtkdialog/box_splash -fg yellow -bg red -close never -text

if [ $llDialogRun -eq "1" ]; then

/usr/lib/gtkdialog/box_splash ${lcDialogColor} -close never -text "
.        ... Please Wait ... ${gcVerDts} ... DEX
.         B2T :  Tar is Creating 'tar.gz' BackUp
.             Wait for USB devices to finish
.
.
.
.              ... Progress Dialog ...
.
.
.
.
. PupSaveNameTrg is : ${lcPupSaveNameTrg##*/} :" &
#-----------------------------------------------------------------------

            GTKPIDmain=$!    ### This is the Main "BackGround" screen.
            sleep 2
else
    ### else dialog the simplest possible. 
    ### code from HB.v.1.2 original , always with 'default' colors .
    B2T_Show_Splash "${lcMsgStr}..."
            GTKPIDmain=${!}
            sleep 2
fi

        ############################################################
        ### the Main Splash is open as background
        ### other Splash will display inside the Main Splash.
        ############################################################

        ### Subsequent Splash will layer over / blend with the large Main Splash.
        ### Master Splash should linger until after the final dialog splash "Done" is cleared.

        ### Careful !  Maintain sequence of change dir .
        ### change dir from PWDir to  ${1%/*}
        ### then run tar .

        ###~ ### this "change dir" is only necessary if PWDir was NOT local.
        ###~ ### because B2T will never move away from the "saveDATA" subdir.
        ###~ cd ${1%/*} ### dirname $B2T_PUPSAVE_PATH

        ### tar calls zip with "1" fast compression, Trg , Src
        ### tar -c -z  -f ${destfile##*/} ${1##*/}/    ### fastest

        ###--- B2T_Backup -------
        ### This is Before 'tar' process :
        ### echo this trace to terminal
     lcMsgStr="...................................................." && Sys_Str2Trm   "${lcMsgStr}"   "blu" "3"
     lcMsgStr="$ {1} is ${1} : last param in buffer" && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"
     lcMsgStr="$ {1%/*} <<<<<<< subdir of  saveDATA short form" && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"
     lcMsgStr="$ {1%/*} is ${1%/*} <<< last param in buffer. " && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"
     lcMsgStr="cd $ {1%/*} is /mnt/home/pup_UpupBB+20 <<< " && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"
     lcMsgStr="....................................................." && Sys_Str2Trm   "${lcMsgStr}"   "blu" "3"
    ### ref ### Pupsave_Zipit original v12 had "export LOCDEFAULT="/mnt/home"

        ### CD into subdir of "saveDATA"
        ### ... use /path/name chopped, "short form".
        ### so,  ${1} is last param in buffer.
        ### so,  ${1%/*} is "short form" of last param in buffer.
        ### so,  cd ${1%/*} is cd /mnt/home/pup_UpupBB+19
    ### ref ### Pupsave_Zipit original v12 had "export LOCDEFAULT="/mnt/home"

        lcMsgStr="<<< cd ${1%/*} >>>" && Sys_Str2Trm   "${lcMsgStr}"   "red" "3"
        cd ${1%/*} ### dirname $B2T_PUPSAVE_PATH   <<< loc of savedata

        ############################################################
        ### the Main Splash yellow/red is still open as background .
        ### other Splash will display on top the Main Splash .
        ############################################################

########################################################################
###*** SPLASH: Tar Started *********************************************
###*** SPLASH: Tar Started *********************************************
###*** SPLASH: Tar Started *********************************************

lcMsgStr="Tar started" && Sys_Str2Trm "$lcMsgStr" "red" "3"
lcDialogColor="  -fg yellow -bg green  "

###~ /usr/lib/gtkdialog/box_splash -fg yellow -bg green -close never -text "$lcMsgStr" &

if [ $llDialogRun -eq "1" ]; then

/usr/lib/gtkdialog/box_splash  $lcDialogColor -close never -text "
       $lcMsgStr                       .
 " &

            GTKPIDts=$!
            ### kill GTKPIDts later
else
    ### code from HB.v.1.2 original , always with 'default' colors .
    B2T_Show_Splash "${lcMsgStr}..."
            GTKPIDts=${!}
            sleep .1
fi

            ####################################################################
            ### B2T_Tar_Opt is hard coded, now.
            ### We declare/assign value to var 'TAROPT' and 'TAREXT'
            ### gae,
            ###     simple default to "tar.gz" format for 'simple local backup'
            ###     with No Questions Asked.
            ####################################################################

    lcMsgStr="-----------------------------" && Sys_Str2Trm "$lcMsgStr" "blu" "3"
    lcMsgStr="begin tar >>>>>>>>>>>>>>>>>>" && Sys_Str2Trm "$lcMsgStr" "red" "3"
    lcMsgStr="Trg: ${lcPupSaveNameTrg}" && Sys_Str2Trm "$lcMsgStr" "pur" "3"
    lcMsgStr="Src: ${lcPupSaveNameSrc}" && Sys_Str2Trm "$lcMsgStr" "pur" "3"
    lcMsgStr="trg=/initrd/mnt/dev_save/pup_UpupBB+20/upupbbsave-BB19+20-1202" && Sys_Str2Trm "$lcMsgStr" "yel" "3"

            ### read
            ### good place for "read" to allow checking parameters
            ### in the GEANY "Execute" Terminal Window.
            
            ### begin simple color string to terminal so tar process shows     
            /bin/echo -n -e ""  
            /bin/echo -n -e "\\033[1;36m" 

            ###------------------------------------------------------------
            ### begin: tar process
            ###------------------------------------------------------------
            
            TAROPT="-c -z --checkpoint=500" ###----'c'reate 'v'erbose 'z'ip)

            tar ${TAROPT} -f ${lcPupSaveNameTrg} ${lcPupSaveNameSrc}

            ###------------------------------------------------------------
            ### end: tar process
            ###------------------------------------------------------------

            /bin/echo -e "\\033[0;m" 
            ### end simple color string to terminal so tar process shows    

           lcMsgStr="End:  tar <<<<<<<<<<<<<<<<<<<<" && Sys_Str2Trm   "${lcMsgStr}"   "red" "3"
           echo

            RETVAL=$?   ### from 'tar' process.
            lcMsgStr="RETVAL= ${RETVAL} -------" && Sys_Str2Trm   "${lcMsgStr}"   "grn" "3"
            lcTarRetVal="$RETVAL"   ### B2T standard var name.
            lcMsgStr="lcTarRetVal= $lcTarRetVal -------" && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"

        #######################################################################################
        ### this code for external check on valid 'tar' process will not run on UpupBB system. 
 		### show_splash "Running e2fsck on backup -- please wait"
        #~ lcMsgStr="Running e2fsck on backup -- please wait" && Sys_Str2Trm   "${lcMsgStr}"   "grn" "3"
		#~ e2fsck -y "${lcPupSaveNameTrg}" 2> /B2Z_e2fsck.txt
		#~ RETVAL=$?   ### from 'e2fsck' process.
        #~ lcMsgStr="RETVAL e2fsck = ${RETVAL} -------" && Sys_Str2Trm   "${lcMsgStr}"   "grn" "3"
        #~ kill $pidx
        # Results: 
        # "e2fsck 1.44.1 (24-Mar-2018) "
        # "e2fsck: Bad magic number in super-block "
        # "while trying to open upupbbsave-BB19+20-1202.BKP-200602-2306-24.tar.gz "
        #######################################################################################
        
            ### parse for the 'RETVAL' from tar :  0=no-error , 1=error .
            if [ $lcTarRetVal -eq "1" ]; then
                echo "****** "
                echo "Tar Message : 'File NOT Found' / 'InValid' ..."
                echo "****** "

                ### xmessage "ERROR"
                xmessage -name 'B2T' -center -bg blue -fg yellow " $0 is already running. "

                #---------------------------------------------------------------
                #~ /usr/lib/gtkdialog/box_ok "ERROR" error "Tar File NOT Found Error ..."
                ### ERROR 'box_ok' clears itself, will not stop program.
                ###
                ### we decided to make this a "non-fatal" error ,
                ### the user should 'report' this error .
                ###
            fi

            ###--- B2T_Backup ------------------------------------------


###=====================================================================

        ### Before and After the 'tar' process , the subdir is different:
        ### this 'cd' "$CWDir" is :
        ### after 'execute' tar
        ### after 'if' test on RetVal
        ### So, Main processes have run
        ### ... now, it is time to "change dir" back to 'home' subdir .
        ###

        lcMsgStr="cd  CWDir= $ CWDir  is $CWDir <<<" && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"
        lcMsgStr="cd  orig subdir in long 'path' form <<<" && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"

        cd "$CWDir" ### point back to 'home' .

        lcMsgStr="change dir 'CWDir' ... point back to 'home' dir " && Sys_Str2Trm   "${lcMsgStr}"   "grn" "3"

###=====================================================================

        ###--- B2T_Backup -------
        ###
        ### ref ### Pupsave_Zipit original v12 had "export LOCDEFAULT="/mnt/home"
        ###
        ### for now, 
        ### We have the 'RETVAL' from tar :  0=no-error , 1=error .
        ###   and have checked for error flag.
        ###*********************************************************************

            ############################################################
            ### the Main Splash is still open as background
            ### other Splash will display inside the Main Splash.
            ############################################################

            #~ echo "trace: DialogColor: ${lcDialogColor} ======="
            #~ echo "trace: DialogRun: ${llDialogRun} ======="

########################################################################
###*** SPLASH: DONE ****************************************************
###*** SPLASH: DONE ****************************************************
###*** SPLASH: DONE ****************************************************

lcMsgStr="... B2T is DONE ..." &&  Sys_Str2Trm "$lcMsgStr" "red" "3"
lcDialogColor="  -fg yellow -bg blue  "

###~ /usr/lib/gtkdialog/box_splash -fg yellow -bg red -close never -text "$lcMsgStr"

if [ $llDialogRun -eq "1" ]; then

/usr/lib/gtkdialog/box_splash  $lcDialogColor -close never -text " $lcMsgStr " &

            GTKPIDdone=${!}
            sleep 1

else
    ### code from HB.v.1.2 original , always with 'default' colors .
    B2T_Show_Splash "${lcMsgStr}..."
            GTKPIDdone=${!}
            sleep .1
            ### kill later.
fi

        ### These will overlay all previous splash
        ### and over the Main_Splash 
        ### kill later.

###*********************************************************************

        ### wait for flash drive to shuffle data.
        echo "trace: GtkDialog boxes will return 'terminated' message "
        echo "... when the 'kill' PID command is applied"
        echo "trace: wait for USB-Flash-Drive to shuffle data at 10 MB per second ."
 

###*********************************************************************

            ### Back-Step thru all "kill PID"
            ### Killing all previous splash in reverse order .

            sleep .1
            kill ${GTKPIDmain}
            echo "==========> kill GTKPIDmain ---"
            ###

            sleep .1
            kill ${GTKPIDsp}
            echo "==========> kill GTKPIDsp ---"
            ###

            sleep .1
            kill ${GTKPIDts}
            echo "==========> kill GTKPIDts ---"
            ###

            sleep .1
            kill ${GTKPIDdone}
            echo "==========> kill GTKPIDdone ---"
            ###

    ### sync    ### write all buffered blocks to disk
                ### will lock if SnapMergePuppy is running. 
                ### will not run if PartEd is busy. 

########################################################################
### Main_Gui calls EXIT:BackUpCall, calls fx B2T_BackUpRun
### runs thru to here.
### This Must Clear all pid, so Main_GUI does not stack up.
### Calling $0 recalls this program ... all clean.

lcMsgStr=">>> calling: Cleanup ... Unlock ..." && Sys_Str2Trm "$lcMsgStr" "grn" "3"

rm -r "${B2T_lockfile}"  ### release 'running' status.

lcMsgStr=">>> calling:  ReStart B2T ... Again ===>" && Sys_Str2Trm "$lcMsgStr" "red" "3"

### State:  "DONE" 

	### $0 & ### reenter ### re-run this program
	### exit 1 ### just in case , to prevent stack overflow.


########################################################################
    ### end : B2T_BackUpRun -------
    ### end : B2T_BackUpRun -------
}   ### end : B2T_BackUpRun -------
#-------------------------------

### all function() moved to top of code
### all function() moved to top of code
### all function() moved to top of code













### all Main_Gui function() moved to bottom of code
### all Main_Gui function() moved to bottom of code
### all Main_Gui function() moved to bottom of code

########################################################################
#######    MAIN()   ####################################################
#######    MAIN()   ####################################################
#######    MAIN()   ####################################################
########################################################################


    #~ lcMsgStr=">>> call Sys_SetVerDts for date based variables... " && Sys_Str2Trm "$lcMsgStr" "grn" "3"
    #~ Sys_SetVerDts   ###     ### B2T_StartUp calls
    
    #~ ### trace results to terminal screen.
    #~ lcMsgStr="VerDts: ${gcVerDts} ......." && Sys_Str2Trm   "${lcMsgStr}"   "3" "10"
    #~ lcMsgStr="SysDts: ${lcSysDts} ......." && Sys_Str2Trm   "${lcMsgStr}"   "3" "10"
    #~ lcMsgStr="NowDts: ${lcNowDts} ......." && Sys_Str2Trm   "${lcMsgStr}"   "3" "10"


### borrowed from: "/etc/rc.d/rc.Str2Trm"
### Entry Splash in color 
lcMsgStr="Begin: B2T : Main() : TERMINAL Mode :"
Sys_Str2Trm "$lcMsgStr" "1" "1"
Sys_Str2Trm "$lcMsgStr" "2" "2"
Sys_Str2Trm "$lcMsgStr" "3" "3"
Sys_Str2Trm "$lcMsgStr" "4" "4"
Sys_Str2Trm "$lcMsgStr" "5" "5"
Sys_Str2Trm "$lcMsgStr" "6" "6"
Sys_Str2Trm "$lcMsgStr" "7" "7"

echo 

### if Only 1 instance
if [ "`top -n 1 | grep ${0}`" ]; then
    lcMsgStr=" ${0} is already running. " && Sys_Str2Trm "$lcMsgStr" "pur" "3"
   xmessage -name 'B2T' -center -bg blue -fg yellow " $0 is already running. "
   exit
fi 

### if frugal install.
MODE="`grep PUPMODE /etc/rc.d/PUPSTATE | cut -f 2 -d "="`"
if [ "$MODE" = "12" ] || [ "$MODE" = "13" ]; then
    lcDummy=0
    lcMsgStr="grep PupMode in PUPSTATE is OK " && Sys_Str2Trm "$lcMsgStr" "pur" "3"
else
    xmessage -name 'B2T' -center -bg yellow -fg blue " MODE is not '12' or '13' "
    lcMsgStr="MODE is not '12' or '13' " && Sys_Str2Trm "$lcMsgStr" "pur" "3"
   exit
fi

### Assign/Declare: path of currently mounted save file.
### Hard Code the Puppy Linux Default MntHome subdir 
lcSaveDataName="/mnt/home""`grep PUPSAVE /etc/rc.d/PUPSTATE | cut -f 3 -d "," | cut -f 1 -d "'" `"
lcMsgStr="saveFILE : ${lcSaveDataName}" && Sys_Str2Trm "$lcMsgStr" "pur" "3"
    
########################################################################
### Now, continue through all normal Start-Up routines.
########################################################################


sleep 1

###################### Locate String
### ... Main()
### ... Main ()
### ... Main_()
###################### Locate String

### PATH borrowed from: "/etc/rc.d/rc.sysinit"
###  plus :  "/usr/lib/gtkdialog/"
#~ lcMsgStr="Path incl gtkdialog" && Sys_Str2Trm "$lcMsgStr" "pur" "3"
#~ PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/usr/lib/gtkdialog/:

########################################################################
###  begin B2T_lock_file  block  #######################################
###  begin B2T_lock_file  block  #######################################
###  begin B2T_lock_file  block  #######################################

### check on "already running" status ###
### B2T_check_lock_file
###   cannot be written as a subroutine
###   at this level of program stack
###   if we require a full 'exit' from B2T script.
### Stack will not 'pop' properly.
### Written into Main(), right here !
###    so that a single 'exit'  
###     will exit the program script totally .
### This is a 'clean' fix for a possible 'fatal' error .
###

    lcMsgStr="*** begin Main() B2T_LockFile ... " && Sys_Str2Trm "$lcMsgStr" "grn" "3"

    ### Check "Run Twice" ---------------------------------------------
    if [ "`top -n 1 | grep ${0}`" ]; then
       lcMsgStr=" ${0} is already running. " && Sys_Str2Trm "$lcMsgStr" "pur" "3"
       xmessage -name 'B2T' -center -bg blue -fg yellow " Error: $0 is Running Twice ! "
       exit
    fi 

    ### check for LockFile status ---------------------------------------
    #
    ### gae, generate the name of the 'lock-file', unique to "B2T" program.
    ### declare / assign value to 'B2T_lockfile'
    B2T_lockfile="/tmp/B2T_backup_lock"
    B2T_lockval='0'

    if [ -f "$B2T_lockfile" ];then

       #------------------------------------------------------------------
        #~ /usr/lib/gtkdialog/box_ok "ERROR" -text "\
        #~ .        ... B2T_Running_Already
        #~ .        ... (1) Must Quit B2T program
        #~ .        ... (2) Must Clear Running B2T window
        #~ .        ... (3) Must Re-Start B2T program"
        #------------------------------------------------------------------

        ### if previous lockfile is found, then throw a flag, cleanup.
        ### User must clear lingering splash manually,
        ### then restart program. "
        ### box_ok requires user to hit the 'OK' button to clear box_ok splash.

        B2T_lockval="1"    ### raise error flag

        xmessage -name 'B2T' -center -bg yellow -fg blue " Error: Locked "

        ### Developmental factors to consider :
        ### (1) leaving the lock-file in place, prevents re-running program.
        ### (2) removing the lock-file will allow a re-entry ...
        ###     then fresh re-entry can clear lock-file properly.
        ### Else,
        ### (3) the user can get locked-out because main script faulted fatally
        ###     and left the lock-file in place.
        ###     User will not know where to go to clear the lock-file.
        ### Therefore,
        ### (4) we leave the 'back-door' open for 're-entry'.
        ###--------------------------------------------------------------

        ### file unlock
        rm -r "${B2T_lockfile}"  ### release 'running' status.

        ### rationale :
        ### the method written here allows user to ReStart.
        ### (1) User has been warned,
        ### (2) but, this also allows next run program to be a possible 'twice' run.
        ### (3) thus, the user will not be 'locked-out' of next program 'run'. 

        ### Note: 
        ### SaveDATA (File or Folder) must be "Static" ( so the data will be pure )  
        ### SaveDATA (File or Folder) must be "Static" ( no SnapMergePuppy running )  
        ### Any Other system processes which write into the saveDATA must be on 'hold'.  
        ### otherwise, there is (logically) possible erroneous data transferred 
        ### into the Backup.tar.gz file.  
        ### This cautionary note is the reason that our S2F (Save2Flash) program 
        ### makes use of the "nice" process to prioritize "snapmergepuppy" to a high level, 
        ### thus placing other system functions on 'hold' during the Save2Flash operation. 
        ###
        
        exit 1      ### this WILL exit from B2T script at this 'base' stack level ... this is Good!

        ### ideally,
        ###     user will wait for current session to finish.
        ###     then restart 'B2T' program.
        ### else
        ###     user will clear lingering splash, manually.
        ###     then restart 'B2T' program.
        ###     There will be NO Fatal fault if B2T is 'restarted' twice. 
        ###
        ### Otherwise, if B2T  is  "Ctrl-C" halted    
        ###     and thus does not remove the lock-file 
        ### then 're-entry' would NOT possible.
        ### Then, the only fix is to REBOOT, 
        ###     or call the IT tech to manually 'rm' the lock-file.
        ###
        ### Current 'lock-file' method will allow user to 're-start' B2T
        ###     even though there may be a 'currently running' session.
        ###     We find no 'fatal' problems, 
        ###         as long as the saveDATA is "STATIC" ;   
        ###         ie, as long as "SnapMergePuppy" is not running. 
        ###
        ### There are logical issues here, with some solutions,
        ### but that is getting beyond the scope of the B2T process.
        ###
    fi

    ### Now,  RESET the lock-file, via 'touch',
    ###     and keep running this session.
    touch "${B2T_lockfile}"
    ### remove this lockfile at end of "QUIT", bottom of code.
    ### at the 'base' level of program stack.

###  end B2T_lock_file block  ##########################################
###  end B2T_lock_file block  ##########################################
###  end B2T_lock_file block  ##########################################
########################################################################

###^^^ Main() ^^^^^^^

### At this point, B2T is OK to activate.
### gather all values required for running.

lcMsgStr=">>> call B2T_StartUp" && Sys_Str2Trm "$lcMsgStr" "red" "3"

B2T_StartUp     ### >>>>>>>>>>>>>>>>>>>>>>>>

        #~ if [ $PUPMODE -ne 13 ] && [ $PUPMODE -ne 12 ] ; then
            ### we are assuming this system is a saveFOLDER or saveFILE.4fs
            #~ lcDummy=0
        #~ fi


### MAIN GUI #####################################################################
### MAIN GUI #####################################################################
### MAIN GUI #####################################################################
### MAIN GUI #####################################################################
### MAIN GUI #####################################################################
### MAIN GUI #####################################################################


    ### NOTE :
    ### gae, outline of Main_GUI elements
    ###
    ###  Main GUI
    ### outline
    ###     "window"
    ###     "vbox"
    ###         "frame" ("label")
    ###         "frame" ("text1" "text2" "B2T_TrgDts" "timer")
    ###     "hbox" (button 1,2,3 )
    ###
    ### ### "B2T_TrgDts" has local usage within Main_Gui()
    ### ### this "B2T_TrgDts" var receives the
    ### ###      <action>refresh:B2T_TrgDts</action>
    ### ### and shows one-second interval refreshed info.


    ### export Marks each NAME for automatic export to the environment
    ### of subsequently executed commands.
    ### If VALUE is supplied, assign VALUE before exporting.

    ### note:
    ###     calling HELP via command 'embedded' in 'button' .
    ###         will force a return to the 'button'
    ###         No program 'restart' required.
    ### 			<label>  'Help=' </label>
    ###             <action>B2T_Help_Box</action>
    ### note:
    ###     calling "BackUp" via routine outside the Main_Gui() .
    ###         allows good control.
    ###			<label>  'Backup+' </label>
    ###			<action>EXIT:BACKUP+</action>
    ###         Capture and Execute via "Fall-Thru" method. 
    ###
    ########################################################################

###################### find String
### ... MainGui
### ... Main_GUI
### ... Main Gui
###################### find String
#~ default_width="450"

#--------------------------------------------------------------------
### this shows the "DONE" status on Title Line of GUI.
B2T_BackUpStatus="/tmp/B2T_BackUp_Status"
### activated via a "ReStart" of "B2T" script. 
if [ -f "${B2T_BackUpStatus}" ]; then 
    export lcBackUpState="Done..."
    rm -f /tmp/B2T_BackUpStatus.txt
else    
    export lcBackUpState="..."
fi
### "<span color='"'$lcGuiColor'"'> <b> 'Back-2-Tar...${lcBackUpState}' </b> </span> <span color='"'green'"'>     v:'${gcVerDts}.' </span>              " 

 
#--------------------------------------------------------------------
lcMsgStr=">>> Start Main GUI" && Sys_Str2Trm "$lcMsgStr" "red" "3"

lcGuiColor3="green"
lcGuiColor2="blue"
lcGuiColor1="darkred"
 
export B2T_Main_Gui='
<window title=". 'Back-2-Tar-saveDATA' "icon-name="gtk-convert"  >

<vbox>
    <frame>
    <hbox>
        <text editable="false" use-markup="true" xalign="0">
            <label> 
            "<span color='"'$lcGuiColor1'"'> <b>  'Back-2-Tar...' </b> </span>  <span color='"'$lcGuiColor3'"'> <b>'${lcBackUpState}'</b> </span>  <span color='"'$lcGuiColor2'"'>  '${gcVerDts}.'  </span>           " 
            </label>
       </text>
        <button label="" has-focus="false">  <action>EXIT:SRC+</action>  </button>
    </hbox>
    </frame>
    <frame     Note: B2T :   Back-2-Tar    for Puppy Frugal Systems >  
        <text editable="false" use-markup="true" xalign="1">
            <label> 
            " <b> Saves to original location  </b>                    "
            </label>
       </text>
         <text height-request="36" xalign="0">
                <variable>'B2T_TrgDts'</variable>
                <input> 'B2T_TrgFilename' "'\$B2T_PUPSAVE_PATH'" </input>
       </text>
       <timer milliseconds="true" interval="'${REFRESH_INTERVAL}'" visible="false">
               <action>refresh:B2T_TrgDts</action>
       </timer>
    </frame>

	<hbox>
         <button> <label>" "</label>  <action>lcDummy:Abutton</action> </button> 
         <button has-focus="false">
			<input file icon="gtk-ok"></input>
			<label>"'Help'"</label>
            <action>B2T_Help_Box</action>
         </button>
                <button label=" " has-focus="false">  <action>lcDummy:Bbutton</action>  </button>
		 <button has-focus="false">
			<input file icon="gtk-yes"></input>
			<label>  'BackUp' </label>
			<action>EXIT:BackUpCall</action>
		 </button>
                <button label=" " has-focus="false">  <action>lcDummy:Cbutton</action>  </button>
         <button   has-focus="true">
            <label> "'Quit'" </label>
            <input file icon="gtk-no"></input>
            <action>EXIT:QUIT</action>
         </button>
                <button label=" " has-focus="false">  <action>lcDummy:Dbutton</action>  </button>
        <text editable="false" use-markup="true" xalign="0">
            <label>"           " </label>
        </text>
        <button> <label>""</label>  <action>lcDummy:SRC</action> </button> 

	</hbox>
    <hbox>
        <button label="" has-focus="false" height-request="8" > <action>lcDummy:0</action> </button>
    </hbox>

</vbox>
</window>
'
### now 'eval'/execute the main_GUI code.
### can Execute arguments as a shell command.
lcMsgStr=">>> eval B2T_Main Gui" && Sys_Str2Trm "$lcMsgStr" "red" "3"

eval "`gtkdialog --center -p B2T_Main_Gui`"

###     end:  B2T_Main_Gui


##################################

### Results from main_GUI : 

### on HELP:
    ### Calls HELP directly, then simply returns to Button.

### on BackUp: "EXIT:BackUpCall" ,
    ### which falls thru to method, which calls  fx BackUpRun, which was exported,

### on EXIT: "EXIT:QUIT" ,
    ### which falls thru to method


### End of MAIN GUI ####################################################
### End of MAIN GUI ####################################################
### End of MAIN GUI ####################################################





#=======================================================================
### BELOW:
### These blocks run after MAIN GUI selection : "Help" "Backup" "Quit" .
### These are normal running block.




########################################################################
### begin "HELP+" block
### has been handled by embedding call into the GUI line, above.
### This method does not 'stack' the calls, if repeated. 
### This method makes "HELP" return directly to the GUI, quickly. 
### "HELP" could be handled here, just as "SRC+" is handled, 
###     but then must call 'Re-Start'.
### end "HELP+" block

########################################################################




    

########################################################################
#~ echo "Source Display Message Window------------------------------------"
### "EXIT:SRC+"
### purpose: Display Source Code in message window. 

if [ "$EXIT" = "SRC+" ] ; then

    lcdummy=0

    lcMsgStr=">>> SRC+ " && Sys_Str2Trm "$lcMsgStr" "red" "3"
    lcMsgStr="   Will 'stack' pid calls if repeated.  " && Sys_Str2Trm "$lcMsgStr" "grn" "3"

    Sys_Src_Box    ### local function name

    lcMsgStr="<<< SRC+ " && Sys_Str2Trm "$lcMsgStr" "red" "3"

    ### will RESTART script auto ### via MGN ReStart method .
    B2T_ReStart

fi
### end EXIT:SRC+



########################################################################
#~ echo "BACKUP Call Standard --------------------------------------------"
###
### EXIT:BackUpCall
if [ "$EXIT" = "BackUpCall" ] ; then

    lcDummy=0

    lcMsgStr=">>> Call fx BackUpRun " && Sys_Str2Trm "$lcMsgStr" "red" "3"

    ### run function 'BackUpRun' , Assume SavePath and BackPath are valid.
    B2T_BackUpRun "$B2T_PUPSAVE_PATH" "$B2T_BACKUP_PATH"

    lcMsgStr="<<< Call fx BackUpRun------------------" && Sys_Str2Trm "$lcMsgStr" "red" "3"

    ### Status var for main_GUI message "Done"
    touch "${B2T_BackUpStatus}"   
    
    ### will RESTART script auto ### via MGN ReStart method .
    B2T_ReStart

fi  ### end EXIT:BackUpCall
###-------------------------




########################################################################
### EXIT:QUIT
#~ echo "Common Quit Block -----------------------------------------------"
if [ "$EXIT" = "QUIT" ] || [ "$EXIT" = "" ] ; then

    lcMsgStr=">>> Quit Block " && Sys_Str2Trm "$lcMsgStr" "red" "3"

    rm -f "${B2T_lockfile}"  ### release 'Running' flag.

    rm -f "${B2T_BackUpStatus}" ### release "Done" flag. 


if [ 0 = 1 ] ; then
    /bin/echo -n -e "\\033[1G" 
    /bin/echo -n -e "\\033[1;32m" 
lcParStr="
NOTE: 
#######################################################################"
	/bin/echo -n "$lcParStr"  
	/bin/echo -e "\\033[0;m" 
    echo
fi

    ### at this point, process leaves the script.
    ### B2T will simply "Fall-Out" .

    ### QUIT: DO NOT RESTART B2T script auto ###
    ### QUIT: DO NOT !!!  ReStart
    ### SIMPLY FALL OUT !
    ### When run via "MGN" 'manager' 
    ### then "MGN" will handle a "restart" back into the "MGN" program.

    ### This display is for the Ending of the Terminal DeBug Session : 

    echo
    echo
    echo
    echo
    lcMsgStr="... B2T : ReadMe ! ... v:${gcVerDts} ..." && Sys_Str2Trm "${lcMsgStr}" "grn" "7"
    lcMsgStr="...         Tar has Created 'tar.gz' BackUp" && Sys_Str2Trm "${lcMsgStr}" "yel" "7"
    lcMsgStr="...         Wait for USB devices to flush" && Sys_Str2Trm "${lcMsgStr}" "pur" "7"
    echo
    lcMsgStr=">>>  Hit 'Enter' to clear Terminal <<< "
    Sys_Str2Trm "$lcMsgStr" "yel" "7"
    Sys_Str2Trm "$lcMsgStr" "grn" "7"
    Sys_Str2Trm "$lcMsgStr" "cyn" "7"
    echo

    lcMsgStr="<<< Quit >>>" && Sys_Str2Trm "$lcMsgStr" "red" "3"


    exit 0
    
fi  ### end: "$EXIT" = "QUIT"


########################################################################
### Common FALL-THRU "Quit" Block -----------------------------------------------
### end: rc.z_B2T.sh
########################################################################




########################################################################
### gae, Geany  debug method :
### [ "Execute" for BASH-Terminal-Trace-Window ]
### write "echo" commands for tracing in the Terminal Window.
########################################################################


########################################################################
### end of B2T 'Back-2-Tar' program
#=======================================================================
### END ###### END ###### END ###### END ###### END ###### END ######
########################################################################



